<script setup lang="ts">
import type { Booking } from "@/entities";
import { useRoomStore } from "@/stores/room";
import { computed } from "@vue/reactivity";
import { onMounted } from "@vue/runtime-core";
import type { Dayjs } from "dayjs";
import { storeToRefs } from "pinia";
import { stringToColour } from '../form-helpers'

const props = defineProps<{
    bookings:Booking[],
    date:Dayjs,
    switchable: boolean
}>();

const roomStore = useRoomStore();
const { rooms } = storeToRefs(roomStore);

const roomsWithBooking = computed(() => {

    const list = [];
    for (const room of rooms.value) {
        list.push({
            ...room,
            am: props.bookings.find((item) => item.room?.id == room.id && props.date.hour(12).isAfter(item.startDate) && props.date.hour(12).isBefore(item.endDate)) || {startDate: props.date.hour(12).toDate(), endDate: props.date.hour(12).toDate(), room},
            pm: props.bookings.find((item) => item.room?.id == room.id &&  props.date.hour(14).isAfter(item.startDate) &&  props.date.hour(12).isBefore(item.endDate)) ||  {startDate: props.date.hour(14).toDate(), endDate: props.date.hour(14).toDate(), room}
        })
    }
    return list;
})



const emit = defineEmits({
    changeDay(days:number){return true},
    dateSelect(booking:Booking){return true}
});

const arrowClick = (days:number) => {
    emit('changeDay', days);
}

onMounted(() => {
    roomStore.fetchRooms();

});

</script>

<template>
    <div class="common-layout">

        <h1 :key="date.unix()">
            <el-icon v-if="switchable" class="icon" color="#ce0033" @click="arrowClick(-1)">
                <ArrowLeft />
            </el-icon>
            Journée du {{ date.format('DD/MM') }}
            <el-icon v-if="switchable" class="icon" color="#ce0033" @click="arrowClick(1)">
                <ArrowRight />
            </el-icon>
        </h1>
        <el-row :gutter="20">
            <el-col :md="6" v-for="roomBooking of roomsWithBooking">

                <el-card>
                    <template #header>
                        {{ roomBooking.name }}
                    </template>

                    <p>matin :
                        <el-tag v-if="roomBooking.am.promo" @click="emit('dateSelect', roomBooking.am)" effect="dark" :color="stringToColour(roomBooking.am.promo.name)">
                            {{ roomBooking.am.promo.name }}
                        </el-tag>

                        <el-tag v-if="!roomBooking.am.promo" @click="emit('dateSelect', roomBooking.am)" type="info">
                            libre
                        </el-tag>
                    </p>
                    <p>aprèm :
                        <el-tag v-if="roomBooking.pm.promo" @click="emit('dateSelect', roomBooking.pm)" effect="dark" :color="stringToColour(roomBooking.pm.promo.name)">
                            {{ roomBooking.pm.promo.name }}
                        </el-tag>

                        <el-tag v-if="!roomBooking.pm.promo" @click="emit('dateSelect', roomBooking.pm)" type="info">
                            libre
                        </el-tag>
                    </p>
                </el-card>
            </el-col>
        </el-row>


    </div>
</template>

<style scoped>
.el-card {
    margin-bottom: 20px;
}
.el-tag {
    border: none;
}
.icon {
    cursor:pointer;
}

.card-header {
    display: flex;
    justify-content: space-between;
    align-items: center;
}

.text {
    font-size: 14px;
}

.item {
    margin-bottom: 18px;
}
</style>